                                                                             
#define _HAL_C_                                                                
                                                                               
/******************************************************************************
 *                             Include File Section                           *
 ******************************************************************************/
#include "hal.h"
#include "uart.h"
#include "spi.h"
                                                                               
/******************************************************************************
 *                         Private Macro Define Section                       *
 ******************************************************************************/
                                                                               
/******************************************************************************
 *                             Struct Define Section                          *
 ******************************************************************************/
                                                                               
/******************************************************************************
 *                           Prototype Declare Section                        *
 ******************************************************************************/
static void halGpioInit(void);
static void halWdgInit(void);
static void halExtiInit(void);
static void halTimerInit(void);
static void halUsartInit(void);
//uint32 hal_get_cpu_clock_frequence(uint32 hxosc_frequence);

/******************************************************************************
 *                        Global Variable Declare Section                     *
 ******************************************************************************/
                                                                               
/******************************************************************************
 *                     File Static Variable Declare Section                   *
 ******************************************************************************/
                                                                               
/******************************************************************************
 *                           Function Declare Section                         *
 ******************************************************************************/
/*============================== External Function ===========================*/
/****************************************************************
 * Function Name: halMCUInit
 * Decription   : Initialize the MCU.
 * Calls        : 
 * Called By    : 
 * Input        : None
 * Output       : None
 * Return Value : None
 * Others       : None
 *------------------------- Revision History -------------------
 * No. Version Date      Revised by   Item      Description     
 * 1   V1.0    2011-1-23                   
 *****************************************************************/
void halMCUInit(void)
{
    halSysClkInit(HROSC, SYS_CLOCK_DIV_1);
    halGpioInit();
    halWdgInit();
    halSpiInit();
    halExtiInit();
    halTimerInit();
    halUsartInit();
}

/*******************************************************************************
R8C/L35Cһ5ʱԴֱXIN,XCIN,HRC,LRC,WDTRC
XIN     XCIN        HRC     LRC     WDTRC
0~20M   32.768K     ~40M    125K    125K
*******************************************************************************/
/*******************************************************************************
 *      : halSysClkInit(UINT8 clksrc, UINT8 div)
 *    : ʱԴӦķƵ
 *              HROSCȡĬֵ36.864M2ƵڴڲʼС
 *    : clksrc - ʱԴ(HXOSC,LXOSC,HROSC,LROSC)
 *              div - ƵȡSYS_CLOCK_DIV_1SYS_CLOCK_DIV_2 ...
 *    : 
 *     ֵ : ýȡ ɹorЧ
 *    : 
 * ú 
 *        עڲɺԶ˼Ĵ
*******************************************************************************/
uint8 halSysClkInit(uint8 clkosc, uint8 div)
{
    REG_PROTECTED_DISABLE(REG_PROTECTED_0);
    if (clkosc == HXOSC)
    {
        HIGH_SPEED_CRYSTAL_ENABLE();            
    }
    else if(clkosc == LXOSC)
    {
        LXOSC_PUTIN_ENABLE();       
    }
    else if(clkosc == HROSC)
    {
        HROSC_FREQUENCE_DIV_SET(HROSC_FREQUENCE_DIV_2);
        HROSC_FREQUENCE_SET(HROSC_FREQUENCE_36M864);        
    }
    else if(clkosc == LROSC)
    {
    }
    else 
    {
        REG_PROTECTED_ENABLE(REG_PROTECTED_0);
        return HAL_PARA_INVALID;
    }
    
    //жϷƵǷ
    if ((div == SYS_CLOCK_DIV_1)
        || (div == SYS_CLOCK_DIV_2)
        || (div == SYS_CLOCK_DIV_4)
        || (div == SYS_CLOCK_DIV_8)
        || (div == SYS_CLOCK_DIV_16)
        )
    {
        /*ʱӲΪʱԴ */
        SYS_CLOCK_DIV_SET(div); 
        OSCILLATOR_RUN(clkosc);
        SYS_CLOCK_SOURCE_SET(clkosc);
        REG_PROTECTED_ENABLE(REG_PROTECTED_0);
        return HAL_RETURN_OK;
    }
    else
    {
        REG_PROTECTED_ENABLE(REG_PROTECTED_0);
        return HAL_PARA_INVALID;
    }
}

/****************************************************************
* Function Name: halSetDataRate
* Decription   : 趨Ĳ
* Calls        : 
* Called By    : 
* Input        : 趨Ϊ12244896144,192,384,576,1152
*                ʽΪHAL_12_DATARATE
* Output       : None
* Return Value : None
* Others       : None
*------------------------- Revision History -------------------
* No. Version Date       Revised by   Item      Description     
* 1   V1.0    2011-03-07          Original Version              
*****************************************************************/
/*
void halSetDataRate(en_halDataRate datarate)
{
  switch(datarate)
  {
   case HAL_12_DATARATE:
        u0c0  = UART_CLK_F8|UART_TXD_OPEN|UART_MSB_LAST;
        u0brg = 119;
        break;
   case HAL_24_DATARATE:
        u0c0  = UART_CLK_F8|UART_TXD_OPEN|UART_MSB_LAST;
        u0brg = 59;
        break;
   case HAL_48_DATARATE:
        u0c0  = UART_CLK_F8|UART_TXD_OPEN|UART_MSB_LAST;
        u0brg = 29;
        break;
   case HAL_96_DATARATE:
        u0c0  = UART_CLK_F1|UART_TXD_OPEN|UART_MSB_LAST;
        u0brg = 119;
        break;
   case HAL_144_DATARATE:
        u0c0  = UART_CLK_F1|UART_TXD_OPEN|UART_MSB_LAST;
        u0brg = 79;
        break;
   case HAL_192_DATARATE:
        u0c0  = UART_CLK_F1|UART_TXD_OPEN|UART_MSB_LAST;
        u0brg = 59;
        break;
   case HAL_384_DATARATE:
        u0c0  = UART_CLK_F1|UART_TXD_OPEN|UART_MSB_LAST;
        u0brg = 29;
        break;
   case HAL_576_DATARATE:
        u0c0  = UART_CLK_F1|UART_TXD_OPEN|UART_MSB_LAST;
        u0brg = 19;
        break;
   case HAL_1152_DATARATE:
        u0c0  = UART_CLK_F1|UART_TXD_OPEN|UART_MSB_LAST;
        u0brg = 9;
        break;
   default:   // 2400
        u0c0  = UART_CLK_F8|UART_TXD_OPEN|UART_MSB_LAST;
        u0brg = 59;
        break;
  }
}
*/
/****************************************************************
 * Function Name: halIwdgInit
 * Decription   : Initialize the Independent Watchdog.
 * Calls        : 
 * Called By    : halInitMcu()
 * Input        : None
 * Output       : None
 * Return Value : None
 * Others       : None
 *------------------------- Revision History -------------------
 * No. Version Date      Revised by   Item      Description     
 * 1   V1.0    2011-1-23      Original Version             
 *****************************************************************/
void halSoftReset(void* pArg)
{
    prc1 = 1;
    pm03 = 1;
    prc1 = 1;
}

/*============================== Internal Function ===========================*/
/****************************************************************
 * Function Name: halGpioInit
 * Decription   : 
 * Calls        : 
 * Called By    : halInitMcu()
 * Input        : None
 * Output       : None
 * Return Value : None
 * Others       : None
 *------------------------- Revision History -------------------
 * No. Version Date      Revised by   Item      Description     
 * 1   V1.0    2011-1-23      Original Version             
 *****************************************************************/
static void halGpioInit(void)
{
    // ָʾIOڣΪ
    pd4           = 0xff;
    p4pur         = 0xff;
    p4            = 0xff;

    pd0_2         = 1;
    pu02_p0pur    = 1; 
    p0_2          = 1;
    
    //TEST_TX_DIR   = INPUT;
    //TEST_TX_PULL  = 1;
    //TEST_RX_DIR   = INPUT;
    //TEST_RX_PULL  = 1;
    //TEST_COM_DIR  = INPUT;
    //TEST_COM_PULL = 1;  
    
    SDN_DIR = OUTPUT;
    SDN     = 0;

    // Si4432ӽӿ
    GP_CLK_DIR     = INPUT;
    GP_CLK_PULL    = 1;
    GP_RX_DAT_DIR  = INPUT;
    GP_RX_DAT_PULL = 1;
    GP_TX_DAT_DIR  = OUTPUT;

    //halWait(20);
}

/****************************************************************
 * Function Name: halWdgInit
 * Decription   : Initialize the Window Watch Dog.
 * Calls        : 
 * Called By    : halInitMcu()
 * Input        : None
 * Output       : None
 * Return Value : None
 * Others       : None
 *------------------------- Revision History -------------------
 * No. Version Date      Revised by   Item      Description     
 * 1   V1.0    2011-1-23      Original Version             
 *****************************************************************/
static void halWdgInit(void)
{ 
  // Źʱ (Ƶ*0x3FFFF)/CPUʱ
    prcr  = 3;    // ȥpm1Ĵд
    pm12  = 0;    // Źʱʱ 0:Źж 1:λMCU
    prcr  = 0;
    wdtc7 = 1;    // ŹʱӷƵѡ 0:16   1:128

    wdtr = 0x00;  // ι
    wdtr = 0xFF;
    //wdts = 0xFF;  // Ź
}

/****************************************************************
 * Function Name: halExtiInit
 * Decription   : 
 * Calls        : 
 * Called By    : halInitMcu()
 * Input        : None
 * Output       : None
 * Return Value : None
 * Others       : None
 *------------------------- Revision History -------------------
 * No. Version Date      Revised by   Item      Description     
 * 1   V1.0    2011-1-23      Original Version             
 *****************************************************************/
static void halExtiInit(void)
{
   intsr = EINT_LOC_SET_PORT_3;  // INT0ŷ䵽p30; 
   
   // Si4432CLK(GPIO1)P3_1
   //EINT_INPUT_FILTER_SET(1, EINT_INPUT_FILTER_NULL); //f1˲
   EINT_ENABLE(1, INT_ON);  // ⲿ1ж
   EINT_POLARITY_SET(1, EINT_POLARITY_ONE);
   EINT_EDGE_SET(1, EINT_EDGE_RISING);
   EINT_LEVEL(1, INT_LEVEL_6);
}

/****************************************************************
 * Function Name:halTimerInit
 * Decription   : (trapre+1)*(tra+1)=f
 * Calls        : 
 * Called By    : halInitMcu()
 * Input        : None
 * Output       : None
 * Return Value : None
 * Others       : None
 *------------------------- Revision History -------------------
 * No. Version Date      Revised by   Item      Description     
 * 1   V1.0    2011-1-23      Original Version             
 *****************************************************************/
static void halTimerInit(void)
{
    // TRA 
    tramr  = TIMER_RA_MODE_TIMER|TIMER_RA_TCK_F8;
    trapre = 71;
    tra    = 31;  // 1ms

    traic  = INT_LEVEL_4;
    TIMER_RA_RUN();

    // TRB
    //trbmr  = TIMER_RA_MODE_TIMER|TIMER_RA_TCK_F8;
    //trbpre = 143;
    //trbpr  = 159;  //10ms
    //trbpre = 71;
    //trbpr  = 31;  //10ms
    
    //trbic  = INT_LEVEL_4;
    //TIMER_RB_RUN();
    //TIMER_RB_INT(0);
    
    // TRC
    // ж = (trcgra/f8) s
    //trccr1       = 0x30;  // ԴѡΪf8 = (36.864M/2)/8 = 2.304M
    //cclr_trccr1  = 1;     // TRCGRAȽƥʱTRC
    //imiea_trcier = 1;     // ȽƥAж
    //trcgra       = 2304;  // Ƚƥֵ 16bit(1ms) 

   // trcic        = INT_LEVEL_4;
    //TIMER_RC_RUN();
}

/****************************************************************
 * Function Name: halUsartInit
 * Decription   : 
 * Calls        : 
 * Called By    : halInitMcu()
 * Input        : None
 * Output       : None
 * Return Value : None
 * Others       : None
 *------------------------- Revision History -------------------
 * No. Version Date      Revised by   Item      Description     
 * 1   V1.0    2011-1-23      Original Version             
 *****************************************************************/
static void halUsartInit(void)
{
    /* -------------------- USART1 configuration -----------------*/
    /* USART1 configured as follow:
       - Word Length = 8 Bits
       - 1 Stop Bit
       - Even parity
       - BaudRate = 9600 baud=UiBRG = 36.864M/F/baudrate/16 - 1
       - Tx and Rx enabled
       -
    */
    u0sr = UART_USE_RXDTOP132|UART_USE_TXD;
    u0mr = UART_BITS_8|UART_STOP_BIT_ONE|UART_PARITY_EVEN;
    u0c0 = UART_CLK_F1|UART_TXD_OPEN|UART_MSB_LAST;
    u0c1 = 0x10;

    //halSetDataRate(HAL_96_DATARATE);
    u0c0  = UART_CLK_F1|UART_TXD_OPEN|UART_MSB_LAST;   // 9600
    u0brg = 119;
    
    //u0tbl= 'S';
    UART_RX_ENABLE(0);
    UART_TX_ENABLE(0);
    //UART_TX_IT_OPEN;
    UART_RX_IT_OPEN;
}

/****************************************************************
 * Function Name: hal_get_cpu_clock_frequence
 * Decription   : get cpu clock
 * Calls        : 
 * Called By    : 
 * Input        : None
 * Output       : None
 * Return Value : None
 * Others       : None
 *------------------------- Revision History -------------------
 * No. Version Date      Revised by   Item      Description     
 * 1   V1.0    2011-1-23                   
 *****************************************************************/
/*
#define HXOSC_FREQUENCE 8000000 
uint32 hal_get_cpu_clock_frequence(uint32 hxosc_frequence)
{
    uint32 cpu_frq;
    
    cpu_frq = CUP_CLOCK_FREQUENCE();
    if (cpu_frq <= CPU_CLOCK_FREQUENCE_XHOSC_DIV16)
    {
        cpu_frq = hxosc_frequence / cpu_frq;
    }
    return cpu_frq;
}
*/

/****************************************************************
 * Function Name: halWait
 * Decription   : 
 * Calls        : 
 * Called By    : 
 * Input        : None
 * Output       : None
 * Return Value : None
 * Others       : None
 *------------------------- Revision History -------------------
 * No. Version Date      Revised by   Item      Description     
 * 1   V1.0    2011-1-23                   
 *****************************************************************/
void halWait(uint8 wait)
{
    uint32 clk;
    
    while (wait)
    {
        clk = CPU_CLOCK_FREQUENCE_18M432;
        clk = ((clk*5) >> 15)/6 + 1;
        while(clk--);
        wait--; 
        FEED_WATCHDOG;
        FEED_EXT_WATCHDOG;
    }
}

/****************************************************************
 * Function Name: halDelayUs
 * Decription   : usʱ
 * Calls        : None
 * Called By    : None
 * Input        : (1)uiTCntUS: ΢
 * Output       : None
 * Return Value : None
 * Others       : uiTCntUSȡֵ󲻳1000
 *------------------------- Revision History -------------------
 * No. Version Date      Revised by   Item      Description     
 * 1   V1.0    2011-2-21     Original Version 
 *****************************************************************/
void halDelayUs(uint32 uiTCntUS)
{

}
