                                                                  
/******************************************************************************
 *                             Multi-Include-Prevent                          *
 ******************************************************************************/
#ifndef _HAL_H_                                                                
#define _HAL_H_                                                                
                                                                               
/******************************************************************************
 *                              Debug Switch Section                          *
 ******************************************************************************/
                                                                               
/******************************************************************************
 *                             Include File Section                           *
 ******************************************************************************/
#include <io_r8cl35c.h>
#include "common.h"

/******************************************************************************
 *                          Pubilc Macro Define Section                       *
 ******************************************************************************/
#ifdef _HAL_C_
#define HAL_EXT
#else
#define HAL_EXT extern
#endif

typedef void(*FUNCTIONPOINTER)(void);

/*******************************************************************************
λ
*******************************************************************************/
#ifndef BV
#define BV(n)   (0x01 << n)
#endif

typedef enum
{
  HAL_12_DATARATE,
  HAL_24_DATARATE,
  HAL_48_DATARATE,
  HAL_96_DATARATE,
  HAL_144_DATARATE,
  HAL_192_DATARATE,
  HAL_384_DATARATE,
  HAL_576_DATARATE,
  HAL_1152_DATARATE  
} en_halDataRate;

/*******************************************************************************
HALֵ
*******************************************************************************/
//HALֵ
#define HAL_FAILED              0x00    //ʧܣԭ
#define HAL_RETURN_OK           0XFF    //ɹ
#define HAL_PARA_INVALID        0x01    //Ч
#define HAL_TARGET_UNSUPPORT    0x02    //Ŀ겻֧

/*----------------------------------LED----------------------------------*/
/*******************************************************************************
//Ŀһ6ֻLED
LED1        LED2        LED3        LED4        LED5        LED6
P4_0        P4_1        P4_2        P4_3        P4_4        P4_5
Rx          Tx          RF_R        RF_T        CH1         CH0
*******************************************************************************/
#define LED1 p4_0
#define LED2 p4_1
#define LED3 p4_2
#define LED4 p4_3
#define LED5 p4_4
#define LED6 p4_5

//LED
#define LED_ON(led)  p4 &= ~(0x01 << led)
#define LED_OFF(led) p4 |= (0x01 << led)
#define LED_OFF_ALL  p4 |= 0X3F
#define LED_ON_ALL   p4 &=~ 0X3F
#define LED_TOG(led) p4 ^= (0x01 << led)

typedef enum
{
    HAL_LED_RX,        // ڽָʾ(̵)
    HAL_LED_TX,        // ڷָʾ()
    HAL_LED_RF_RX,     // ָ߽ʾ()
    HAL_LED_RF_TX,     // ߷ָʾ()
    HAL_LED_CHAN1,     // ŵָʾ(ɫ)
    HAL_LED_CHAN0      // ŵָʾ(ɫ)
} en_phyLedState;

/*====================== LEDƹܽ =====================*/
//ŵָʾ:ɫLED 
#define LED_CH_GREEN_ON           LED_ON(HAL_LED_CHAN0) 
#define LED_CH_GREEN_OFF          LED_OFF(HAL_LED_CHAN0) 

//ŵָʾ:ɫLED 
#define LED_CH_RED_ON             LED_ON(HAL_LED_CHAN1) 
#define LED_CH_RED_OFF            LED_OFF(HAL_LED_CHAN1) 

//շָʾ
#define LED_RF_RX_ON              LED_ON(HAL_LED_RF_RX) 
#define LED_RF_RX_OFF             LED_OFF(HAL_LED_RF_RX) 
#define LED_RF_RX_TRIG            LED_TOG(HAL_LED_RF_RX)
#define LED_RF_TX_ON              LED_ON(HAL_LED_RF_TX) 
#define LED_RF_TX_OFF             LED_OFF(HAL_LED_RF_TX) 
#define LED_RF_TX_TRIG            LED_TOG(HAL_LED_RF_TX)

// շָʾ
#define LED_UART_RX_ON            LED_ON(HAL_LED_RX)
#define LED_UART_RX_OFF           LED_OFF(HAL_LED_RX)
#define LED_UART_TX_ON            LED_ON(HAL_LED_TX)
#define LED_UART_TX_OFF           LED_OFF(HAL_LED_TX)

/*----------------------------------IO----------------------------------*/

/*******************************************************************************
ҪIO
*******************************************************************************/
#define R_SET       p3_1
#define R_STA       p3_2
#define R_EVENOUT   p3_3

#define DISABLE_INTERRUPT  asm("FCLR I")
#define ENABLE_INTERRUPT   asm("FSET I")

/****************************************************************************
  IO
*******************************************************************************/
#define TEST_TX_PIN    p2_4
#define TEST_TX_DIR    pd2_4
#define TEST_TX_PULL   pu24

#define TEST_RX_PIN    p0_7
#define TEST_RX_DIR    pd0_7
#define TEST_RX_PULL   pu07

#define TEST_COM_PIN    p0_6
#define TEST_COM_DIR    pd0_6
#define TEST_COM_PULL   pu06

/*******************************************************************************
SI4432GPIOоƬ
*******************************************************************************/
#define  SI4432_GPIO1                 p3_1
#define  SI4432_GPIO2                 p4_7
#define  SI4432_GPIO1_DIR             pd3_1
#define  SI4432_GPIO2_DIR             pd4_7
#define  SI4432_GPIO1_PULL            pu31 
#define  SI4432_GPIO2_PULL            pu47

/*******************************************************************************
ֱͨģʽշ
*******************************************************************************/

#define  RF_DIRECT_RX           do{   spiWriteAddrByte(GPIO2Configuration,GPIO_RX_DATA|0x20);  \
                                      spiWriteAddrByte(OperatingFunctionControl1,RXON); \
                                      GP_RX_DAT_DIR = INPUT; GP_RX_DAT_PULL = 1;}while(0)


#define  RF_DIRECT_TX          do {   spiWriteAddrByte(OperatingFunctionControl1,TXON|XTALON); \
                                                                   spiWriteAddrByte(GPIO2Configuration,GPIO_TX_DATA|0x20);  \
                                                                    GP_TX_DAT_DIR = OUTPUT;}while(0)

#define  RF_BIT_INT_OFF            EINT_ENABLE(1, INT_OFF)

#define  RF_BIT_RX_INT_ON          do{ EINT_ENABLE(1,INT_OFF);\
                                       EINT_EDGE_SET(1,EINT_EDGE_FALLING);\
                                       EINT_FLAG_CLEAR(1);\
                                       EINT_ENABLE(1, INT_ON);\
                                      }while(0)
 
#define  RF_BIT_TX_INT_ON          do{ EINT_ENABLE(1,INT_OFF);\
                                       EINT_EDGE_SET(1,EINT_EDGE_RISING);\
                                       EINT_FLAG_CLEAR(1);\
                                       EINT_ENABLE(1, INT_ON);\
                                      }while(0)

#define  NIRQ_INPUT_PIN               p3_0 //INT0
#define  NIRQ_DIR                     pd3_0
#define  NIRQ_PULL                    pu30

#define  SDN                          p11_4
#define  SDN_DIR                      pd11_4
#define  SDN_PULL                     pu114

#define  INPUT                        0
#define  OUTPUT                       1

#define LOW 0
#define HIGH 1

/*******************************************************************************
  Ƶշ
*******************************************************************************/
#define  RF_LNA_ON           {  pd7_4 =1;p7_4 = 1;}
#define  RF_LNA_OFF          {  pd7_4 =1;p7_4 = 0;}
#define  RF_PA_ON            {  pd7_5 =1;p7_5 = 1;}
#define  RF_PA_OFF           {  pd7_5 =1;p7_5 = 0;}

/*******************************************************************************
  ֱͨģʽշ
*******************************************************************************/
// GPIO1ΪRFʱţGPIO2Ϊշ
#define  GP_CLK              SI4432_GPIO1
#define  GP_RX_DAT           SI4432_GPIO2
#define  GP_TX_DAT           SI4432_GPIO2

#define  GP_CLK_DIR          SI4432_GPIO1_DIR
#define  GP_RX_DAT_DIR       SI4432_GPIO2_DIR
#define  GP_TX_DAT_DIR       SI4432_GPIO2_DIR

#define  GP_CLK_PULL         SI4432_GPIO1_PULL
#define  GP_RX_DAT_PULL      SI4432_GPIO2_PULL
#define  GP_TX_DAT_PULL      SI4432_GPIO2_PULL

#define  GPIO2_INPUT_PIN     GP_RX_DAT
#define  GPIO2_OUTPUT_PIN    GP_TX_DAT

/*******************************************************************************
  SPIӿ
*******************************************************************************/
#define  SPI_SCLK           p11_0
#define  SPI_SDI            p11_2
#define  SPI_SDO            p11_1
#define  SPI_CS             p11_3

#define  SPI_SCLK_DIR       pd11_0
#define  SPI_SDI_DIR        pd11_2
#define  SPI_SDO_DIR        pd11_1
#define  SPI_CS_DIR         pd11_3

#define  SPI_SCLK_PULL      pu110
#define  SPI_SDI_PULL       pu112
#define  SPI_SDO_PULL       pu111
#define  SPI_CS_PULL        pu113

/*******************************************************************************
GPIOGPIO⹦ܣADC
*******************************************************************************/
// IO˿˵
// R8C/L35Cϵ12˿ڣֱP0~P7,P10~P13

// IOķ
#define IO_DIR_PORT_PIN(port, pin, dir) \
    do                                  \
    {                                   \
        pd##port## &= ~BV(pin);         \
        pd##port## |= (dir == IO_OUT) ? BV(pin) : 0x00; \
    }while(0)
// dirȡ
#define IO_IN   0
#define IO_OUT  1

// IO
#define IO_PULL_PORT_PIN(port, pin, pull) \
    do                                      \
    {                                       \
        p##port##pur &= ~BV(pin);           \
        p##port##pur |= (pull == IO_PULL) ? BV(pin) : 0x00; \
    }while(0)
// imodeȡ
#define IO_NPULL    0
#define IO_PULL     1

// ѡ񣬽P10,P11Ч
#define IO_DRV_PORT_PIN(port, pin, drv)     \
    do                                          \
    {                                           \
        p##port##ddr &= ~BV(pin);               \
        p##port##ddr |= (drv == IO_DRV_HIGH) ? BV(pin) : 0x00;\
    }while(0)
// drvȡ
#define IO_DRV_LOW  0
#define IO_DRV_HIGH 1   

    



// ʹⲿپҪռP12_0,P12_1
#define HIGH_SPEED_CRYSTAL_ENABLE()     cm1 |= 0x08
#define HIGH_SPEED_CRYSTAL_DISABLE()    cm1 &= ~0x08

// IOã
//UTX0,P13_1 UTX0,P13_2/P11_4
//UTX1,P4_0, URX1,P4_1

// ʵ
// IO_PER_LOC_UTXD0_AT_PORT13_PIN1();
// IO_PER_LOC_URXD0_AT_PORT13_PIN2();
// õIO
#define IO_PER_LOC_UTXD0_AT_PORT13_PIN1()   do{ u0sr |= 0x01; }while(0)                 //TXD0ռP13_1
#define IO_PER_LOC_URXD0_AT_PORT13_PIN2()   do{ u0sr = (u0sr & ~0x0c) | 0x04;}while(0)  //RXD0    P13_2
#define IO_PER_LOC_URXD0_AT_PORT11_PIN4()   do{ u0sr = (u0sr & ~0x0c) | 0x08;}while(0)  //RXD0    P11_4
// ΪռIO
#define IO_PER_LOC_UART0_RELEASE()  do{ u0sr &= ~0x0f;}while(0) //UARTIO

// 1õIO
#define IO_PER_LOC_UTXD1_AT_PORT4_PIN0()    do{ u1sr |= 0x01; }while(0)                 //TXD1ռP4_0
#define IO_PER_LOC_URXD1_AT_PORT4_PIN1()    do{ u1sr |= 0x04; }while(0)                 //RXD1    P4_1
// ΪռIO
#define IO_PER_LOC_UART1_RELEASE()  do{ u1sr &= ~0x5; }while(0)

/*******************************************************************************
ʱ
*******************************************************************************/
//ʱѡ
#define HXOSC   0x01    //ⲿپ      <20M
#define LXOSC   0x02    //ⲿپ      32.7368K
#define HROSC   0x03    //ڲ      Լ40M
#define LROSC   0x04    //ڲ      Լ125K
//ϾΪCPUʱ
#define WDTROSR 0X05    //ڲŹ    Լ125K,CPUʱ

//ʼ񵴣ûжWDT
#define OSCILLATOR_RUN(osc)     \
    do                              \
    {                               \
        if(osc == HXOSC)            \
        {                           \
            cm05 = 0;               \
        }                           \
        else if (osc == LXOSC)      \
        {                           \
            cm03 = 1;               \
            asm("NOP");             \
            cm03 = 0;               \
        }                           \
        else if (osc == HROSC)      \
        {                           \
            fra00 = 1;              \
        }                           \
        else if (osc == LROSC)      \
        {                           \
            cm14 = 0;               \
        }                           \
    }while(0)

//ֹͣ񵴣ûжWDT
#define OSCILLATOR_STOP(osc)        \
    do                              \
    {                               \
        if(osc == HXOSC)            \
        {                           \
            cm05 = 1;               \
        }                           \
        else if (osc == LXOSC)      \
        {                           \
            cm03 = 1;               \
        }                           \
        else if (osc == HROSC)      \
        {                           \
            fra00 = 0;              \
        }                           \
        else if (osc == LROSC)      \
        {                           \
            cm14 = 1;               \
        }                           \
    }while(0)
    
    

//ϵͳʱӷƵ
#define SYS_CLOCK_DIV_SET(dev)  \
    do                      \
    {                       \
        cm1 &= ~0xc0;       \
        cm0 &= ~0x40;       \
        if (dev == SYS_CLOCK_DIV_8)     \
        {                               \
            cm0 |= 0x40;                \
        }                               \
        else                            \
        {                               \
            cm1 |=  dev;                \
        }                               \
    }while(0)           
//ϵͳʱӿ·Ƶѡ    
#define SYS_CLOCK_DIV_1         0X00
#define SYS_CLOCK_DIV_2         0X40
#define SYS_CLOCK_DIV_4         0X80
#define SYS_CLOCK_DIV_8         0X20
#define SYS_CLOCK_DIV_16        0XC0
            
//ϵͳʱӷƵ          
#define SYS_CLOCK_DIV() (   \
    (cm06 == 1) ? SYS_CLOCK_DIV_8:  \
    ((cm17 == 0) && (cm16 == 0)) ? SYS_CLOCK_DIV_1: \
    ((cm17 == 0) && (cm16 == 1)) ? SYS_CLOCK_DIV_2: \
    ((cm17 == 1) && (cm16 == 0)) ? SYS_CLOCK_DIV_4: \
    (SYS_CLOCK_DIV_16))
    
/*----------------------------------ѡʱԴ----------------------------------*/  
// R8C/L35CһʱѡҪⲿپʱԴ֮ѡ
//ڶѡҪⲿپڲRC֮ѡ
//ҪڲRC֮ѡͬٶ
            
#define SYS_CLOCK_SOURCE_SET(source)    \
    do                                  \
    {                                   \
        if (source == LXOSC)            \
        {                               \
            cm07 = 1;   \
        }               \
        else            \
        {               \
            cm07 = 0;   \
            if (source == HXOSC)    \
            {                       \
                ocd2 = 0;           \
            }                       \
            else                    \
            {                       \
                ocd2 = 1;           \
                if (source == LROSC)\
                {                   \
                    fra01 = 0;      \
                }                   \
                else                \
                {                   \
                    fra01 = 1;      \
                }                   \
            }                       \
        }                           \
    }while(0)
//source
//LXOSC,HXOSC,LROSC,HROSC
    
/*----------------------------------ѡʱԴ----------------------------------*/

//ֱӶϵͳʱԴ  
#define SYS_CLOCK_SOURCE()  (   \
        (cm07 == 1) ? (LXOSC):  \
        (ocd2 == 0) ? (HXOSC) : \
        (fra01 == 0) ? (LROSC): \
        (HROSC))
    
    
//CPUʱƵһ,λHZ
//#define CPU_CLOCK_FREQUENCE_40M       40000000 //ȡ40M
#define CPU_CLOCK_FREQUENCE_20M     20000000
#define CPU_CLOCK_FREQUENCE_10M     10000000
#define CPU_CLOCK_FREQUENCE_5M      5000000
#define CPU_CLOCK_FREQUENCE_2M5     2500000

//#define CPU_CLOCK_FREQUENCE_36M864    36864000
#define CPU_CLOCK_FREQUENCE_18M432  18432000
#define CPU_CLOCK_FREQUENCE_9M216   9216000
#define CPU_CLOCK_FREQUENCE_4M608   4608000
#define CPU_CLOCK_FREQUENCE_2M304   2304000

//#define CPU_CLOCK_FREQUENCE_32M       32000000
#define CPU_CLOCK_FREQUENCE_16M     16000000
#define CPU_CLOCK_FREQUENCE_8M      8000000
#define CPU_CLOCK_FREQUENCE_4M      4000000
#define CPU_CLOCK_FREQUENCE_2M      2000000

#define CPU_CLOCK_FREQUENCE_32K768  32768
#define CPU_CLOCK_FREQUENCE_16K384  16384
#define CPU_CLOCK_FREQUENCE_8K192   8192
#define CPU_CLOCK_FREQUENCE_4K096   4096
#define CPU_CLOCK_FREQUENCE_2K048   2048

#define CPU_CLOCK_FREQUENCE_150K    150000
#define CPU_CLOCK_FREQUENCE_75K     75000
#define CPU_CLOCK_FREQUENCE_37K5    37500
#define CPU_CLOCK_FREQUENCE_18K75   18750
#define CPU_CLOCK_FREQUENCE_9K375   9375

#define CPU_CLOCK_FREQUENCE_XHOSC_DIV1      0X01
#define CPU_CLOCK_FREQUENCE_XHOSC_DIV2      0X02
#define CPU_CLOCK_FREQUENCE_XHOSC_DIV4      0X04
#define CPU_CLOCK_FREQUENCE_XHOSC_DIV8      0X08
#define CPU_CLOCK_FREQUENCE_XHOSC_DIV16     0X10

//CPUʱƵ
#define CUP_CLOCK_FREQUENCE()   (\
    (SYS_CLOCK_SOURCE() == HROSC) ? (\
    (HROSC_FREQUENCE() == HROSC_FREQUENCE_40M) ? (  \
    (SYS_CLOCK_DIV() == SYS_CLOCK_DIV_4 ) ? CPU_CLOCK_FREQUENCE_10M :  \
    (SYS_CLOCK_DIV() == SYS_CLOCK_DIV_8 ) ? CPU_CLOCK_FREQUENCE_5M :    \
    (SYS_CLOCK_DIV() == SYS_CLOCK_DIV_16 ) ? CPU_CLOCK_FREQUENCE_2M5: \
    (CPU_CLOCK_FREQUENCE_20M ) ) : (\
    (HROSC_FREQUENCE() == HROSC_FREQUENCE_36M864) ? (\
    (SYS_CLOCK_DIV() == SYS_CLOCK_DIV_4 ) ? CPU_CLOCK_FREQUENCE_9M216 : \
    (SYS_CLOCK_DIV() == SYS_CLOCK_DIV_8 ) ? CPU_CLOCK_FREQUENCE_4M608 : \
    (SYS_CLOCK_DIV() == SYS_CLOCK_DIV_16 ) ? CPU_CLOCK_FREQUENCE_2M304: \
    (CPU_CLOCK_FREQUENCE_18M432 ) ) : (\
    (SYS_CLOCK_DIV() == SYS_CLOCK_DIV_4 ) ? CPU_CLOCK_FREQUENCE_8M : \
    (SYS_CLOCK_DIV() == SYS_CLOCK_DIV_8 ) ? CPU_CLOCK_FREQUENCE_4M : \
    (SYS_CLOCK_DIV() == SYS_CLOCK_DIV_16 ) ? CPU_CLOCK_FREQUENCE_2M: \
    (CPU_CLOCK_FREQUENCE_16M ) ))) :    \
    (SYS_CLOCK_SOURCE() == LROSC) ? (   \
    (SYS_CLOCK_DIV() == SYS_CLOCK_DIV_2) ? CPU_CLOCK_FREQUENCE_75K :  \
    (SYS_CLOCK_DIV() == SYS_CLOCK_DIV_4) ? CPU_CLOCK_FREQUENCE_37K5 :  \
    (SYS_CLOCK_DIV() == SYS_CLOCK_DIV_8) ? CPU_CLOCK_FREQUENCE_18K75 :  \
    (SYS_CLOCK_DIV() == SYS_CLOCK_DIV_16) ? CPU_CLOCK_FREQUENCE_9K375 : \
    (CPU_CLOCK_FREQUENCE_150K ) ) : \
    (SYS_CLOCK_SOURCE() == LXOSC) ?  (\
    (SYS_CLOCK_DIV() == SYS_CLOCK_DIV_2) ? CPU_CLOCK_FREQUENCE_16K384 : \
    (SYS_CLOCK_DIV() == SYS_CLOCK_DIV_4) ? CPU_CLOCK_FREQUENCE_8K192 :  \
    (SYS_CLOCK_DIV() == SYS_CLOCK_DIV_8) ? CPU_CLOCK_FREQUENCE_4K096 :  \
    (SYS_CLOCK_DIV() == SYS_CLOCK_DIV_16) ? CPU_CLOCK_FREQUENCE_2K048 : \
    (CPU_CLOCK_FREQUENCE_32K768) ) : (\
    (SYS_CLOCK_DIV() == SYS_CLOCK_DIV_2) ? CPU_CLOCK_FREQUENCE_XHOSC_DIV2 :  \
    (SYS_CLOCK_DIV() == SYS_CLOCK_DIV_4) ? CPU_CLOCK_FREQUENCE_XHOSC_DIV4 :  \
    (SYS_CLOCK_DIV() == SYS_CLOCK_DIV_8) ? CPU_CLOCK_FREQUENCE_XHOSC_DIV8 :  \
    (SYS_CLOCK_DIV() == SYS_CLOCK_DIV_16) ? CPU_CLOCK_FREQUENCE_XHOSC_DIV16 : \
    (CPU_CLOCK_FREQUENCE_XHOSC_DIV1) ))



//ԶLXOSCǷ
#define LXOSC_PUTIN_ENABLE()    cm04 = 1
#define LXOSC_PUTIN_DISABLE()   cm04 = 0

//LXOSCķ/ر
#define LXOSC_FEEDBACK_RESISTOR_ENABLE()    cm12 = 0
#define LXOSC_FEEDBACK_RESISTOR_DISABLE()   cm12 = 1

//ϵʱĬΪ40M޸ĺֻͨΪ40M
//ڲƵ
#define HROSC_FREQUENCE_SET(fre)        \
    do      \
    {       \
        if (fre == HROSC_FREQUENCE_36M864)  \
        {   \
            fra1 = fra4;    \
            fra3 = fra5;    \
        }   \
        else if(fre == HROSC_FREQUENCE_32M) \
        {   \
            fra1 = fra6;    \
            fra3 = fra7;    \
        }   \
    }while(0)
//freȡֵ
#define HROSC_FREQUENCE_40M         0x00
#define HROSC_FREQUENCE_36M864      0x01    //
#define HROSC_FREQUENCE_32M         0X02

#define HROSC_FREQUENCE()   (   \
    (fra1 == fra4) ? HROSC_FREQUENCE_36M864 : (\
    (fra1 == fra6) ? HROSC_FREQUENCE_32M    : \
    (HROSC_FREQUENCE_40M)))


//ԶڲԤƵ
#define HROSC_FREQUENCE_DIV_SET(div)        \
    do  \
    {   \
        fra2 &= ~0x07;  \
        fra2 |= div;    \
    }while(0)
//ȡ·Ƶֵ
#define HROSC_FREQUENCE_DIV_2       0X00
#define HROSC_FREQUENCE_DIV_3       0X01
#define HROSC_FREQUENCE_DIV_4       0X02
#define HROSC_FREQUENCE_DIV_5       0X03
#define HROSC_FREQUENCE_DIV_6       0X04
#define HROSC_FREQUENCE_DIV_7       0X05
#define HROSC_FREQUENCE_DIV_8       0X06
#define HROSC_FREQUENCE_DIV_9       0X07


/*----------------------------------ʱ----------------------------------*/
uint8 hal_init_cpu_clock(uint8 clkosc, uint8 div);
uint32 hal_get_cpu_clock_frequence(uint32 hxosc_frequence);



/*******************************************************************************
Դ
*******************************************************************************/
#define COUNT_SOURCE_PROTECTD_ENABLE()  cspr |= 0x80
#define COUNT_SOURCE_PROTECTD_DISABLE() cspr &= ~0x80

/*******************************************************************************
Ĵ
bit     protect
0       cm0,cm1,cm3,ocd,fra0,fra1,fra2,fra3
1       pm0,pm1
3       ocvrefcr,vca2,vd1ls,vw0c,vw1c,vw2c
*******************************************************************************/

#define REG_PROTECTED_0     0X01
#define REG_PROTECTED_1     0X02
#define REG_PROTECTED_3     0X04

#define REG_PROTECTED_ENABLE(f)     prcr &= ~f
#define REG_PROTECTED_DISABLE(f)    prcr |= f


/*******************************************************************************
ж
*******************************************************************************/

#define INT_ON      1
#define INT_OFF     0
#define INT_SET     1
#define INT_CLR     0

//ж
#define INUM_BRK        0
#define INUM_FMRDY      1
//#define INUM_         2
#define INUM_INT7       3
#define INUM_INT6       4
#define INUM_INT5       5
#define INUM_INT4       6
#define INUM_RC         7
#define INUM_RD0        8
#define INUM_RD1        9
#define INUM_RE         10
#define INUM_UTX2       11
#define INUM_URX2       12
#define INUM_KEY        13
#define INUM_ADC        14
#define INUM_SPI        15
//#define INUM_         16
#define INUM_UTX0       17
#define INUM_URX0       18
#define INUM_UTX1       19
#define INUM_URX1       20
#define INUM_INT2       21
#define INUM_RA         22
//#define INUM_         23
#define INUM_RB         24
#define INUM_INT1       25
#define INUM_INT3       26
//#define INUM_         27
//#define INUM_         28
#define INUM_INT0       29
#define INUM_UART2CFT   30
//#define INUM_         31
#define INUM_SOFT1      32
#define INUM_SOFT2      33
#define INUM_SOFT3      34
#define INUM_SOFT4      35
#define INUM_SOFT5      36
#define INUM_SOFT6      37
#define INUM_SOFT7      38
#define INUM_SOFT8      39
#define INUM_SOFT9      40
#define INUM_SOFT10     41
//#define INUM_         42
#define INUM_RG         43
//#define INUM_         44~49
#define INUM_VSPU1      50
#define INUM_VSPU2      51
//#define INUM_         52~55
#define INUM_SOFT11     56
#define INUM_SOFT12     57
#define INUM_SOFT13     58
#define INUM_SOFT14     59
#define INUM_SOFT15     60
#define INUM_SOFT16     61
#define INUM_SOFT17     62
#define INUM_SOFT18     63

#define __enable_interrupt()    asm("FSET I")
#define __disable_interrupt()   asm("FCLR I")
#define NBR_OF_INTERRUPTS 64

//жˮƽ
#define INT_LEVEL_1     0X01
#define INT_LEVEL_2     0X02
#define INT_LEVEL_3     0X03
#define INT_LEVEL_4     0X04
#define INT_LEVEL_5     0X05
#define INT_LEVEL_6     0X06
#define INT_LEVEL_7     0X07
#define INT_LEVEL_OFF       0X00    //ж

    
    
/*******************************************************************************
ⲿжϡINT0-7
*******************************************************************************/    
//ж˲  
#define EINT_INPUT_FILTER_SET(intnum,filter)    \
    do  \
    {   \
        if (intnum < 4) \
        {   \
            intf &= ~(0x03 << intnum);  \
            intf |= filter << intnum;   \
        }   \
        else    \
        {   \
            intf1 &= ~(0x03 << (intnum - 4));   \
            intf1 |= filter << (intnum - 4);    \
        }   \
    }while(0)

// intnumȡ0-7
// filterȡֵ
#define EINT_INPUT_FILTER_NULL  0x00   // 00˲
#define EINT_INPUT_FILTER_F1    0x01   // 01˲ͨ f1в
#define EINT_INPUT_FILTER_F8    0x02   // 10˲ͨ f8в
#define EINT_INPUT_FILTER_F32   0x03   // 11˲ͨ f32в
// жϽIOѡ
#define EINT_LOC_SET(intnum,loc)    \
    do                              \
    {                               \
        if(loc == EINT_LOC_SET_PORT_3)  \
        {                           \
            intsr &= ~BV(intnum);   \
        }                           \
        else                        \
        {                           \
            intsr |= BV(intnum);    \
        }                           \
    }while(0)
//intmunȡ0-7
//locȡ
#define EINT_LOC_SET_PORT_3     0
#define EINT_LOC_SET_PORT_11    1

//жϼѡ
#define EINT_POLARITY_SET(intnum,pol)   int##intnum##pl = pol
//intmunȡ0-7
//polȡ
#define EINT_POLARITY_ONE   0
#define EINT_POLARITY_BOTH  1

//жѡѡʱЧ,˫ʱд
#define EINT_EDGE_SET(intnum, edge)     pol_int##intnum##ic = edge
//intmunȡ0-7
//edgeȡ
#define EINT_EDGE_FALLING       0
#define EINT_EDGE_RISING        1

//ⲿжȼѡ
#define EINT_LEVEL(intnum,level)    \
    do  \
    {   \
        int##intnum##ic &= 0xf8;    \
        int##intnum##ic |= level;   \
    }while(0)
//intmunȡ0-7
//level INT_LEVEL_1

//ⲿжϿ  
#define EINT_ENABLE(intnum,on)  int##intnum##en = on
//intmunȡ0-7
//onȡ INT_ON / INT_OFF

//ⲿжϱ־
#define EINT_FLAG_CLEAR(intnum) ir_int##intnum##ic = 0
//intmunȡ0-7

/*******************************************************************************
UART 0/1
*******************************************************************************/

/*******************************************************************************
ʱRA
*******************************************************************************/
//RA¼ģʽ
#define TIMER_RA_MODE_TIMER         0X00
#define TIMER_RA_MODE_PULSE_OUT     0X01
#define TIMER_RA_MODE_EVENT         0X02
#define TIMER_RA_MODE_PULSE_WIDTH   0x03
#define TIMER_RA_MODE_PULSE_CYCLE   0x04

#define TIMER_RA_TCK_BIT            0X70
//RA¼ʱԴ
#define TIMER_RA_TCK_F1             0X00
#define TIMER_RA_TCK_F8             0X10
#define TIMER_RA_TCK_FOCO           0X20
#define TIMER_RA_TCK_F2             0X30
#define TIMER_RA_TCK_FC32           0X40
//0x05ǷǷֵ
#define TIMER_RA_TCK_FC             0X60

//ֹʱ
#define TIMER_RA_TCK_CUT_OFF        0X80    

//ʱ
#define TIMER_RA_RUN()      tracr |= 0x01   
//ֹͣʱ
#define TIMER_RA_STOP()     tracr &= ~0x01

//ʱ
#define TIMER_RB_RUN()      trbcr |= 0x01   
//ֹͣʱ
#define TIMER_RB_STOP()     trbcr &= ~0x01  
//ǿֹͣʱ
#define TIMER_RA_FORCE_STOP()   tracr |= 0x04   

//RAģʽ
#define TIMER_RA_MODE_SET(mode)     \
    do                              \
    {                               \
        tramr &= ~TIMER_RA_MODE_BIT;\
        tramr |= mode;              \
    }while(0)

//RAʱԴ
#define TIMER_RA_TCK_SET(tck)       \
    do                              \
    {                               \
        tramr &= ~TIMER_RA_TCK_BIT; \
        tramr |= tck;               \
    }while(0)

//򿪹رնʱж
#define TIMER_RA_INT(on)      traic = on
#define TIMER_RB_INT(on)      trbic = on
#define TIMER_RC_INT(on)      trcic = on  

#define TMR_ENTER_CRITICAL()  TIMER_RB_INT(0)
#define TMR_EXIT_CRITICAL()   TIMER_RB_INT(5)

// TRC
// ʱ
#define TIMER_RC_RUN()      tstart_trcmr = 1   
// ֹͣʱ
#define TIMER_RC_STOP()     tstart_trcmr = 0


/*******************************************************************************
WDT
*******************************************************************************/
#define WDT_RESET()     wdtr=0; nop();wdtr=0x0ff    //忴Ź
#define FEED_WATCHDOG   { DISABLE_INTERRUPT; \
                          wdtr = 0x00; \
                          asm("nop"); \
                          wdtr = 0xFF;\
                          ENABLE_INTERRUPT;}

#define START_WATCHDOG    { wdts = 0xff;}
#define FEED_EXT_WATCHDOG { p0_2 ^= 1;}

/******************************************************************************
*                          Prototype Declare Section
*******************************************************************************/
HAL_EXT void halMCUInit(void);
HAL_EXT uint8 halSysClkInit(uint8 clkosc, uint8 div);
HAL_EXT void halChannelLedCtrl(void);
HAL_EXT void halSetDataRate(en_halDataRate datarate);
HAL_EXT void halSoftReset(void* pArg);
HAL_EXT void halWait(uint8 wait);
HAL_EXT void halDelayUs(uint32 uiTCntUS);
#endif //hal.h

/*----------------------------------ļ----------------------------------*/