
#define _INTERRUPT_C_                                                                

/******************************************************************************
*                             Include File Section                           *
******************************************************************************/
#include "interrupt.h" 
#include "uart.h"
#include "hal.h"
#include "rf.h" 

//// ̶ж
// δָж
__interrupt void __undefined_instruction_handler(void)
{
}

__interrupt void __NMI_handler(void)
{
}

// BRKָж
__interrupt void __break_instruction_handler(void)
{
}

/****************************************************************
* Function Name: WDG_IRQHandler
* Decription   : ж
* Calls        : 
* Called By    : 
* Input        : None
* Output       : None
* Return Value : None
* Others       : ʱ 0x3FFF*128/40000 = 52 ms
*------------------------- Revision History -------------------
* No. Version Date      Revised by   Item      Description     
* 1   V1.0    2011-1-23    AdhocNet  Original Version             
*****************************************************************/
__interrupt void WDG_IRQHandler(void)
{
    halSoftReset(NULL);
}

//// ɱж
/****************************************************************
* Function Name: TIMA_IRQHandler
* Decription   : This function handles RA global interrupt request.
* Calls        : 
* Called By    : 
* Input        : None
* Output       : None
* Return Value : None
* Others       : úжһΪ1ms
*------------------------- Revision History -------------------
* No. Version Date      Revised by   Item      Description     
* 1   V1.0    2011-1-23    AdhocNet  Original Version             
*****************************************************************/
#pragma vector = 22 
__interrupt void TIMA_IRQHandler(void)
{
    //static uint8 u8Count_10ms = 0;
    static uint16 u16Count_1s = 0;
    
    ENABLE_INTERRUPT;
    
    // 1ms¼

    // 1s¼
    if(++u16Count_1s > 1000)
    {
       u16Count_1s = 0;
    }

    // ڽճʱж
    if(stUart.u8Timer < UART_RX_OVER_TIME)
    {
        stUart.u8Timer++;
    }
    else if(stUart.u8Timer != 0x7F)
    {
        stUart.u8Timer = 0x7F;
        stUart.RxOK    = 1;
    }
}

/****************************************************************
* Function Name: TIMB_IRQHandler
* Decription   : This function handles RB global interrupt request.
* Calls        : 
* Called By    : 
* Input        : None
* Output       : None
* Return Value : None
* Others       : 1msжһΣֻʹ
*------------------------- Revision History -------------------
* No. Version Date      Revised by   Item      Description     
* 1   V1.0    2011-1-23    AdhocNet  Original Version             
*****************************************************************/
#pragma vector = 24 
__interrupt void TIMB_IRQHandler(void)
{
    ENABLE_INTERRUPT;

    //RF_STOP_DECODE_TMR;
    //stRfBuf.u16ValidLength = phyDecodeRfRxFrmLen();    
}

/****************************************************************
* Function Name: TIMC_IRQHandler
* Decription   : ʱRCȽƥж
* Calls        : 
* Called By    : 
* Input        : None
* Output       : None
* Return Value : None
* Others       : 1msжһ
*------------------------- Revision History -------------------
* No. Version Date      Revised by   Item      Description     
* 1   V1.0    2011-1-23    AdhocNet  Original Version             
*****************************************************************/
#pragma vector=7 
__interrupt void TIMC_IRQHandler(void)
{
    static uint16 u16Count = 0;

    imfa_trcsr = 0;     // Ƚƥ־
    ENABLE_INTERRUPT;

    if(u16Count++ > 1000)
    {
       u16Count = 0;
       //LED_TOG(HAL_LED_RF_RX);
       //LED_TOG(HAL_LED_RF_TX);
    }
    
    //RF_STOP_DECODE_TMR;
    //stRfBuf.u16ValidLength = phyDecodeRfRxFrmLen();
}

/****************************************************************
* Function Name: RFշʱж
* Decription   : 
* Calls        : 
* Called By    : 
* Input        : None
* Output       : None
* Return Value : None
* Others       : None
*------------------------- Revision History -------------------
* No. Version Date      Revised by   Item      Description     
* 1   V1.0    2011-4-7     AdhocNet  Original Version             
*****************************************************************/
#pragma vector=25 
__interrupt void EXTI1_IRQHandler(void)
{
    rfBitIntHandlerSimple();
}
