                                                                               
/******************************************************************************
 *                             Multi-Include-Prevent                          *
 ******************************************************************************/
#ifndef _RF_H_                                                                
#define _RF_H_                                                                
                                                                               
/******************************************************************************
 *                              Debug Switch Section                          *
 ******************************************************************************/
                                                                               
/******************************************************************************
 *                             Include File Section                           *
 ******************************************************************************/
#include "common.h"
#include "hal.h"
#include "spi.h"

/******************************************************************************
 *                          Pubilc Macro Define Section                       *
 ******************************************************************************/
#ifdef _RF_C_
#define RF_EXT
#else
#define RF_EXT extern
#endif

#define RF_WORK_MODE_DIRECT     1
#define RF_WORK_MODE_FIFO       2
#define RF_WORK_MODE_PN9        3
#define RF_WORK_MODE            RF_WORK_MODE_DIRECT

#define RF_SYNC1                0x98          //ͬ(ֽ)
#define RF_SYNC2                0xF3          //ͬ(ֽ)
#define RF_PRE1                 0x55          //ǰ1
#define RF_PRE2                 0xAA          //ǰ2
#define RF_PREAMBLE_BYTE        4
#define RF_PREAMBLE_NUM         (RF_PREAMBLE_BYTE<<3)  // (((RF_PREAMBLE_BYTE-1)<<3) + 1)

#define RF_HEADER_LEN           1   // PHYͷ
//#define RF_OFFSET_FREQ          0   // PHYͷƵֽƫ
//#define RF_OFFSET_PRODUCT_ID    1   // PHYͷƷʶƫ
#define RF_OFFSET_LEN           0   // PHYͷֽƫ



#define RF_MAX_SIZE             255 // ((PHY_MAX_PACKET_SIZE>>1)*3 +3)// RFܹܵ󳤶ֽ

/******************************status  2***************************************/
#define SYNCWORD                            0X80
#define VALIDPRE                            0X40
#define INVALIDPRE                          0X20
#define ABOVERSSI                           0X10
#define WAKEUPTIME                          0X08
#define LBD                                 0X04
#define CHIPREADY                           0X02

/********************************status 1***************************************/
#define FIFOWRONG                           0X80
#define TXFIFOALMOSTFULL                    0X40
#define TXFIFOALMOSTEMPTY                   0X20
#define RXFIFOALMOSTFULL                    0X10
#define EXTINTERRUPT                        0X08
#define PKSENT                              0X04
#define VALIDPKRECEIVE                      0X02
#define CRCERROR                            0X01

/**********************************operating mode control1************************/
#define SOFTRESET                           0X80
#define ENLBT                               0X40
#define TXON                                0X08
#define RXON                                0X04
#define PLLON                               0X02
#define XTALON                              0X01

/*********************************Data Acess control**************************/
#define ENPACRXHAND                         0X80
#define LSBFIRST                            0X40
#define CRCDONLY                            0X20 
#define ENPACTXHAND                         0X08
#define ENCRC                               0X04
#define CRC16                               0X01

/*********************************HEADCONTROL 2*******************************/
#define SYNC_TWO_LENGTH                     0X02

/**********************************MODULATIONMODECONTROL2******************/
#define TXCLK_VIA_GPIO                      0X40
#define DIRECTMOD_VIA_GPIO                  0X00
#define FIFO_MODE                           0X20
#define GFSK                                0X03

/*********************************GPIOConfig******************/
#define GPIO_DRV_3                          0xC0
#define GPIO_DIRECT_DIGITAL_OUTPUT          0X0A
#define GPIO_TX_DATA_CLK                    0X0F
#define GPIO_RX_DATA                        0X14
#define GPIO_TX_DATA                        0X10

#define RF_RXFIFO_ALMOST_FULL_NUM           10
#define RF_TXFIFO_ALMOST_EMPTY_NUM          30

/******************************************************************************
 *                             Struct Define Section                          *
 ******************************************************************************/
typedef enum  _RF_POWER
{
   PA_11DBM = 0X04,
   PA_14DBM = 0X05,
   PA_17DBM = 0X06,
   PA_20DBM = 0X07
}en_RfPower;


typedef union
{
    uint8 RfFlg;
    
    struct 
    {
        uint8 PreambleFound   :1;
        uint8 SYNCFound       :1;
        uint8 LastByteSendEnd :1;     // һֽѾ͸RFоƬ()
        uint8 RFBusy          :1;
        uint8                 :4;
    };
}un_RfFlg;  

typedef struct
{
    uint8  Buf[RF_MAX_SIZE];
    uint8  u8RSSI;       // ݰʱRSSIֵ(dbm)
    uint16 Length;       // Ѿ/յֽڼ     
    uint16 TotalLength;  // Ҫ/յܳ
}st_RfBuf;

typedef enum _RF_REG_MAP                    //revX
{
    DeviceType                                = 0x00,
    DeviceVersion                             = 0x01,
    DeviceStatus                              = 0x02,
    InterruptStatus1                          = 0x03,
    InterruptStatus2                          = 0x04,
    InterruptEnable1                          = 0x05,          
    InterruptEnable2                          = 0x06,         
    OperatingFunctionControl1                 = 0x07,
    OperatingFunctionControl2                 = 0x08,
    CrystalOscillatorLoadCapacitance          = 0x09,
    MicrocontrollerOutputClock                = 0x0A,
    GPIO0Configuration                        = 0x0B,
    GPIO1Configuration                        = 0x0C,         
    GPIO2Configuration                        = 0x0D,
    IOPortConfiguration                       = 0x0E,
    ADCConfiguration                          = 0x0F,
    ADCSensorAmplifierOffset                  = 0x10,
    ADCValue                                  = 0x11,
    TemperatureSensorControl                  = 0x12,
    TemperatureValueOffset                    = 0x13,
    WakeUpTimerPeriod1                        = 0x14,          
    WakeUpTimerPeriod2                        = 0x15,         
    WakeUpTimerPeriod3                        = 0x16,         
    WakeUpTimerValue1                         = 0x17,
    WakeUpTimerValue2                         = 0x18,
    LowDutyCycleModeDuration                  = 0x19,       
    LowBatteryDetectorThreshold               = 0x1A,
    BatteryVoltageLevel                       = 0x1B,                          
    IFFilterBandwidth                         = 0x1C,                           
    AFCLoopGearshiftOverride                  = 0x1D,
    AFCTimingControl                          = 0x1E,                              
    ClockRecoveryGearshiftOverride            = 0x1F,              
    ClockRecoveryOversamplingRatio            = 0x20,              
    ClockRecoveryOffset2                      = 0x21,                       
    ClockRecoveryOffset1                      = 0x22,                       
    ClockRecoveryOffset0                      = 0x23,                     
    ClockRecoveryTimingLoopGain1              = 0x24,              
    ClockRecoveryTimingLoopGain0              = 0x25,             
    ReceivedSignalStrengthIndicator           = 0x26,          
    RSSIThresholdForClearChannelIndicator     = 0x27,   
    AntennaDiversityRegister1                 = 0x29,
    AntennaDiversityRegister2                 = 0x2A,
    DataAccessControl                         = 0x30,                          
    EZmacStatus                               = 0x31,                                  
    HeaderControl1                            = 0x32,                               
    HeaderControl2                            = 0x33,                              
    PreambleLength                            = 0x34,                               
    PreambleDetectionControl                  = 0x35,                    
    SyncWord3                                 = 0x36,                                   
    SyncWord2                                 = 0x37,                                   
    SyncWord1                                 = 0x38,                               
    SyncWord0                                 = 0x39,                                
    TransmitHeader3                           = 0x3A,                       
    TransmitHeader2                           = 0x3B,                             
    TransmitHeader1                           = 0x3C,                              
    TransmitHeader0                           = 0x3D,                             
    TransmitPacketLength                      = 0x3E,                         
    CheckHeader3                              = 0x3F,                                
    CheckHeader2                              = 0x40,                              
    CheckHeader1                              = 0x41,                             
    CheckHeader0                              = 0x42,                            
    HeaderEnable3                             = 0x43,                               
    HeaderEnable2                             = 0x44,                                 
    HeaderEnable1                             = 0x45,                                
    HeaderEnable0                             = 0x46,                              
    ReceivedHeader3                           = 0x47,                          
    ReceivedHeader2                           = 0x48,                         
    ReceivedHeader1                           = 0x49,                           
    ReceivedHeader0                           = 0x4A,                             
    ReceivedPacketLength                      = 0x4B,
    AnalogTestBus                             = 0x50,                              
    DigitalTestBus                            = 0x51,                          
    TXRampControl                             = 0x52,                             
    PLLTuneTime                               = 0x53,                            
    CalibrationControl                        = 0x55,                     
    ModemTest                                 = 0x56,                               
    ChargepumpTest                            = 0x57,                    
    ChargepumpCurrentTrimming_Override        = 0x58,         
    DividerCurrentTrimming                    = 0x59,    
    VCOCurrentTrimming                        = 0x5A,                           
    VCOCalibration_Override                   = 0x5B,                    
    SynthesizerTest                           = 0x5C,                              
    BlockEnableOverride1                      = 0x5D,                        
    BlockEnableOverride2                      = 0x5E,                      
    BlockEnableOverride3                      = 0x5F,                       
    ChannelFilterCoefficientAddress           = 0x60,             
    ChannelFilterCoefficientValue             = 0x61,            
    CrystalOscillator_ControlTest             = 0x62,               
    RCOscillatorCoarseCalibration_Override    = 0x63,    
    RCOscillatorFineCalibration_Override      = 0x64,      
    LDOControlOverride                        = 0x65,                          
    DeltasigmaADCTuning1                      = 0x67,
    DeltasigmaADCTuning2                      = 0x68,
    AGCOverride1                              = 0x69,
    AGCOverride2                              = 0x6A,
    GFSKFIRFilterCoefficientAddress           = 0x6B,            
    GFSKFIRFilterCoefficientValue             = 0x6C,              
    TXPower                                   = 0x6D,                                   
    TXDataRate1                               = 0x6E,                            
    TXDataRate0                               = 0x6F,                              
    ModulationModeControl1                    = 0x70,                   
    ModulationModeControl2                    = 0x71,                   
    FrequencyDeviation                        = 0x72,                            
    FrequencyOffset                           = 0x73,                            
    FrequencyChannelControl                   = 0x74,
    FrequencyBandSelect                       = 0x75,                        
    NominalCarrierFrequency1                  = 0x76,                    
    NominalCarrierFrequency0                  = 0x77,                    
    FrequencyHoppingChannelSelect             = 0x79,               
    FrequencyHoppingStepSize                  = 0x7A,                     
    TXFIFOControl1                            = 0x7C,                        
    TXFIFOControl2                            = 0x7D,    
    RXFIFOControl                             = 0x7E,                               
    FIFOAccess                                = 0x7F,
}en_RF_REG_MAP;
                                                                               
/******************************************************************************
 *                        Global Variable Declare Section                     *
 ******************************************************************************/
extern st_RfBuf rfBuf;

/******************************************************************************
 *                            Function Declare Section                        *
 ******************************************************************************/
RF_EXT void rfInit(void);
RF_EXT void rfSetPrmbleLength(uint16 uiPrmbleLen);
RF_EXT bool rfStartTx(void);
RF_EXT void rfStartRx(void);
RF_EXT void rfStop(void);
RF_EXT un_RfFlg rfGetState(void);
RF_EXT void rfBitIntHandlerSimple(void);
RF_EXT void rfSetTxPower(en_RfPower rfpower);
RF_EXT uint8 rfGetRssi(void);
RF_EXT bool rfChannelCCA(void);
//void rfSetFrequency(unsigned long fre);
void rfSetFreq(uint8 u8ChannelGrpFreq);


uint8 rfTx(const uint8 *pbuf,uint8 u8Len);
void rfRx(uint8 *pbuf,uint8  u8Len, uint8  u8RSSI);
#endif


